unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls, Windows;

type
  { TMyBlockingThread }
  TMyBlockingThread = class(TThread)
  private
  protected
    procedure Execute; override;
  public
    Constructor Create(CreateSuspended: boolean);
  end;

  { TMyThread }
  TMyThread = class(TThread)
  private
    fStatusText : string;
    procedure ShowStatus;
  protected
    procedure Execute; override;
  public
    Constructor Create(CreateSuspended: boolean);
  end;

  { TForm1 }
  TForm1 = class(TForm)
    Button1: TButton;
    procedure Button1Click(Sender: TObject);
    procedure OnThreadDone(Sender: TObject);
  private

  public

  end;

var
  Form1:            TForm1;
  MyThread:         TMyThread;
  MyBlockingThread: TMyBlockingThread;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.Button1Click(Sender: TObject);
begin
  if Button1.Caption = 'Start' then
  begin
    MyThread := TMyThread.Create(True); // This way it doesn't start automatically
    MyThread.OnTerminate := @OnThreadDone;
    MyThread.Start;
    MyBlockingThread := TMyBlockingThread.Create(True);
    MyBlockingThread.Start;
    Button1.Caption := 'Stop';
  end
  else if Button1.Caption = 'Stop' then
  begin
    MyThread.Terminate;
    Button1.Caption := 'Start';
  end;
end;

procedure TForm1.OnThreadDone(Sender: TObject);
begin
  Form1.Caption := 'TMyThread Stopped';
end;

procedure TMyThread.ShowStatus;
// this method is executed by the mainthread and can therefore access all GUI elements.
begin
  Form1.Caption := fStatusText;
  Application.ProcessMessages;
  Sleep(400);
end;

constructor TMyThread.Create(CreateSuspended: boolean);
begin
  inherited Create(CreateSuspended);
  FreeOnTerminate := True;
end;

procedure TMyThread.Execute;
var
  newStatus : string;
begin
  // Allocate dynamic objects here
  // MyObject := TObject.Create();

  fStatusText := 'TMyThread Starting...';
  Synchronize(@Showstatus);
  fStatusText := 'TMyThread Timer: ' + FormatDateTime('YYYY.MM.DD HH:NN:SS', Now);
  Synchronize(@Showstatus);
  while (not Terminated) and (not MyBlockingThread.Terminated) do
  begin
    newStatus := 'TMyThread Timer: ' + FormatDateTime('YYYY.MM.DD HH:NN:SS', Now);
    if NewStatus <> fStatusText then
    begin
      fStatusText := newStatus;
      Synchronize(@Showstatus);
    end;
    sleep(300); // save computing capacity power / energy
    if Terminated then
    begin
      // Stop blocking thread
      TerminateThread(MyBlockingThread.Handle, 0);
      //MyBlockingThread.Terminate;
      //MyBlockingThread.DoTerminate;
      //CloseThread(MyBlockingThread.Handle);
      //MyBlockingThread := NIL;
      //MyBlockingThread.CleanupInstance;
      //pthread_cancel(MyThread.Handle);
      //killthread(MyBlockingThread.ThreadID/Handle)
      //MyBlockingThread.Free;
    end;
  end;

  // Destroy dynamic allocated objects here
  // MyObject.Free();

end;

constructor TMyBlockingThread.Create(CreateSuspended: boolean);
begin
  inherited Create(CreateSuspended);
  FreeOnTerminate := True;
end;

procedure TMyBlockingThread.Execute;
begin
  while (not Terminated) do
  begin
    //********************************************************************
    // Hier ist das Problem: Ich möchte blockierende Codeabschnitte
    // im Thread sauber (ohne Memory Leak) und ohne im Hintergrund
    // laufende Prozesse/Threads, die die Prozessorlast erhöhen,
    // unterbrechen!
    //********************************************************************
    while true do ;
  end;
end;

end.

